(*$B- Aufgabe 4.18*)
PROGRAM nickel;
CONST nn=20; eps=2e-12;
TYPE koeff = ARRAY[0..nn] OF real;
VAR ar,ai : koeff; grad,n,i,j : integer;
    xr,xi,h1,h2,rmin,r0,phi0,rj,phij,r,phi,ab : real;
    tf:text; stri: string[20];
(*$I topolar *)
PROCEDURE eingabe;
BEGIN
  writeln('Wohin mit dem Output ?');
  readln(stri); assign(tf,stri); rewrite(tf);
  writeln('Grad a[0],...,a[Grad]');
  read(grad); ab:=0;
  FOR i:=0 TO grad DO
  BEGIN
    read(ar[i],ai[i]);
    ab:=ab+sqrt(sqr(ar[i])+sqr(ai[i]));
  END;
END;
PROCEDURE deflation;
BEGIN
  writeln(tf);
  writeln(tf,'Nst Nr. ',grad+1-n,'  ',xr,xi);
  FOR i:= 1 TO n DO
  BEGIN ar[i-1]:= ar[i]; ai[i-1]:= ai[i] END;
  ar[n]:=xr; ai[n]:=xi;
END;
PROCEDURE nickeliteration;
BEGIN
  topolar(-ar[0],-ai[0],r0,phi0);
  WHILE r0>eps*ab DO
  BEGIN
    rmin:=1e10;
    FOR j:= 1 TO n DO
    BEGIN
      topolar(ar[j],ai[j],rj,phij);
      IF rj<>0 THEN
      BEGIN
        r:=exp(ln(r0/rj)/j);
        IF r<=rmin THEN
        BEGIN
          rmin:=r; phi:=(phi0-phij)/j ;
        END
      END
    END;
    h1:=rmin*cos(phi); h2:=rmin*sin(phi);
    FOR j:=0 TO n DO
    FOR i:=n-1 DOWNTO j DO
    BEGIN
      ar[i]:=h1*ar[i+1]-h2*ai[i+1]+ar[i];
      ai[i]:=h2*ar[i+1]+h1*ai[i+1]+ai[i];
    END;
    xr:=xr+h1; xi:=xi+h2;
    writeln(tf,'X = ',xr:12:7,xi:12:7,'  P(X) = ',ar[0],ai[0]);
    topolar(-ar[0],-ai[0],r0,phi0);
  END
END;
BEGIN
  eingabe; xr:=0; xi:=0;
  FOR n:= grad DOWNTO 1 DO
  BEGIN
    nickeliteration; deflation;
  END;
  writeln(tf); writeln(tf,'Nullstellen');
  FOR i:= 1 TO grad DO writeln(tf,ar[i],' + I*',ai[i]);
  close(tf);
END.
