(*$B- *)
PROGRAM gauss;
CONST nn = 20;
TYPE vektor = ARRAY[1..nn] OF real;
     matrix = ARRAY[1..nn] OF vektor;

VAR a: matrix; b,x : vektor; i,n : integer;  sing : boolean;

    PROCEDURE eingabe( VAR a : matrix; VAR b : vektor);
    VAR i,j : integer;
BEGIN
       writeln('eine Gleichung nach der andern eingeben');
       FOR i:= 1 TO n DO
       BEGIN
 writeln('Gleichung Nr.',i:3);
         FOR j:= 1 TO n DO read(a[i,j]); readln(b[i])
       END
    END;

PROCEDURE singulaer;
BEGIN
  writeln('Matrix ist singulaer');
END;
PROCEDURE rueckwaertseinsetzen(n:integer;
            r:matrix; b:vektor; VAR x:vektor);
VAR i,j : integer; s : real;
(* Algorithmus 5.3 *)
BEGIN
   FOR i:=n DOWNTO 1 DO
   BEGIN
       s:=b[i];
       FOR j:=i+1 TO n DO  s:=s-r[i,j]*x[j];
       x[i] := s/r[i,i];
   END
END;

   PROCEDURE elimination;
   VAR i, j, k, jmax : integer; h : vektor; z, faktor : real;
   BEGIN
     i:=0 ;
   REPEAT
      i:=i+1;
      (* Pivotsuche *)
         jmax:=i;
 FOR j:=i+1 TO n DO
          IF abs(a[j,i])>abs(a[jmax,i]) THEN  jmax:=j;
          sing := a[jmax,i]=0 ;
      IF sing THEN singulaer
      ELSE
      BEGIN
          (*  Gleichungen tauschen *)
          IF jmax <> i THEN
          BEGIN
             h:=a[i]; a[i]:= a[jmax]; a[jmax]:=h;
             z:=b[i]; b[i]:= b[jmax]; b[jmax]:=z
          END;

        (* Elimination *)
         FOR k:= i+1 TO n DO
         BEGIN
            faktor:= a[k,i]/a[i,i];
            FOR j:=i+1 TO n DO
             a[k,j]:=a[k,j]- faktor*a[i,j];
             b[k]:=b[k]-faktor*b[i]
         END
      END
  UNTIL (i=n) OR sing
   END;

BEGIN
  writeln('Wieviele Unbekannte ?'); read(n);
  eingabe(a,b);
  elimination;    
  IF NOT sing THEN 
   BEGIN
      rueckwaertseinsetzen(n,a,b,x);   
  writeln('Loesung');   
  FOR i:= 1 TO n DO write(x[i]);  
   END
END.           




