(*$B- Aufgabe 5.3 *)
PROGRAM lincompl;
CONST nn=20;
TYPE vektor = ARRAY[1..nn] OF real;
     matrix = ARRAY[1..nn] OF vektor;
VAR a: matrix; b,x:vektor; i,n:integer; sing : boolean;

PROCEDURE lies(VAR a:matrix; VAR b:vektor);
VAR i,j : integer;
BEGIN
   writeln('Gleichungen zeilenweise eingeben');
   FOR i := 1 TO n DO
   BEGIN
     FOR j := 1 TO n DO
     BEGIN
       write('Re A[',i:2,',',j:2,']=');
       read(a[i,j]); a[n+i,n+j]:=a[i,j];
       write('Im A[',i:2,',',j:2,']=');
       read(a[n+i,j]); a[i,n+j]:=-a[n+i,j];
       writeln;
     END;
     write('Re b[',i:2,']=');
     read(b[i]);
     write('Im b[',i:2,']=');
     read(b[n+i]);
   END;
END;

PROCEDURE singulaer;
BEGIN
  writeln('Matrix ist singulaer');
END;

(*$I rueckwae (Algorithmus 5.3) *)

PROCEDURE elimination;
VAR i,j,k, jmax: integer; h:vektor; z, faktor : real;
BEGIN
   i:=0;
   REPEAT
      i:=i+1;
      jmax:=i;
      FOR j:=i+1 TO n DO
      IF abs(a[j,i])>abs(a[jmax,i]) THEN jmax:=j;
      sing := a[jmax,i]=0 ;
      IF sing THEN singulaer
      ELSE
      BEGIN
         (* Gleichungen tauschen *)
         IF jmax<>i THEN
         BEGIN
            h:=a[i]; a[i]:=a[jmax]; a[jmax]:=h;
            z:=b[i]; b[i]:=b[jmax]; b[jmax]:=z
         END;

         (* Elimination*)
         FOR k := i+1 TO n DO
         BEGIN
            faktor:=a[k,i]/a[i,i];
            FOR j:=i+1 TO n DO
               a[k,j]:=a[k,j]-faktor*a[i,j];
            b[k]:=b[k]-faktor*b[i]
         END
      END
   UNTIL (i=n) OR sing
END;

BEGIN
  writeln('Wieviele Unbekannte');read(n);
  lies(a,b);
  n:=2*n;
  elimination;
  rueckwaertseinsetzen(n,a,b,x);
  n:=n DIV 2;
  FOR i:= 1 TO n DO
  writeln('Z[',i:2,']=',x[i],' +I* ',x[n+i]);
END.


