(*$B- Aufgabe 5.6 *)
PROGRAM gauss ;
CONST nn=20;
TYPE vektor = ARRAY[1..nn] OF real;
     matrix = ARRAY[1..nn] OF vektor;
VAR aa,a: matrix; b,x:vektor; i,j,n:integer; amax : real;
    tf:text; stri:string[20];

(*$I rueckwae (Algorithmus 5.3) *)

PROCEDURE eingabe(VAR a:matrix; VAR b: vektor);
VAR i,j : integer;
BEGIN
  amax :=0;
  writeln('eine Gleichung nach der anderen eingeben');
  FOR i:=1 TO n DO
  BEGIN
    writeln('Gleichung Nr.',i:3);
    FOR j:=1 TO n DO
    BEGIN
      read(tf,a[i,j]); IF amax<abs(a[i,j]) THEN amax:= abs(a[i,j])
    END;
    readln(b[i]);
  END;
  aa:=a
END;

PROCEDURE ax;
VAR i,j:integer;s:real;
BEGIN
  writeln('A*x=');
  FOR i := 1 TO n DO
  BEGIN s :=0;
    FOR j := 1 TO n DO s := s + aa[i,j]*x[j];
    writeln(s);
  END;
  writeln
END;

PROCEDURE elimination;
VAR i,j,k, jmax: integer; h:vektor; z, faktor : real;

PROCEDURE singulaer;
BEGIN
  writeln('Matrix ist singulaer');
  a[i,i] := amax*1e-11;
END;

BEGIN
  FOR i:=1 TO n DO
  BEGIN
      jmax:=i;
      FOR j:=i+1 TO n DO
      IF abs(a[j,i])>abs(a[jmax,i]) THEN jmax:=j;
      IF  a[jmax,i]=0 THEN singulaer;
      (* Gleichungen tauschen *)
      IF jmax<>i THEN
      BEGIN
         h:=a[i]; a[i]:=a[jmax]; a[jmax]:=h;
         z:=b[i]; b[i]:=b[jmax]; b[jmax]:=z
      END;

      (* Elimination*)
      FOR k := i+1 TO n DO
      BEGIN
         faktor:=a[k,i]/a[i,i];
         FOR j:=i+1 TO n DO
            a[k,j]:=a[k,j]-faktor*a[i,j];
         b[k]:=b[k]-faktor*b[i]
      END
  END
END;

BEGIN
  writeln('von welchem File kommt die Matrix');
  readln(stri); assign(tf,stri); reset(tf);
  writeln('Wieviele Unbekannte'); read(n);
  REPEAT
     eingabe(a,b);
     writeln('gegebene Matrix ');
     FOR i := 1 TO n DO
     BEGIN
        FOR j := 1 TO n DO write(a[i,j]:8:3);
        writeln;
     END;
     elimination;
     writeln('Reduziertes System');
     for i := 1 to n do
     begin
        for j := 1 to i-1 do write(' ':12);
        for j := i to n do write(a[i,j]:11,' ');
        writeln(' ':5,b[i]:11);
     end;
     rueckwaertseinsetzen(n,a,b,x);
     writeln('Loesung');
     FOR i:=1 TO n DO writeln(x[i]);
     ax;
     writeln('Durch welche Unbekannte skalieren?');
     readln(i); amax := x[i];
     FOR j := 1 TO n DO
     BEGIN x[j]:=x[j]/amax; writeln(x[j]) END;
     ax;
     writeln; reset(tf);
     writeln('nochmals ? RET, fertig: CTRL-Z')
  UNTIL eof;
END.

